/*
bhprintlayout.cpp
Copyright (C)2005 Al Kinglsey


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#include <cstring>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>

#include "bhprinter.h"

namespace bhpos{

namespace parser{

CPrintLayoutParser::CPrintLayoutParser()
{
   /*
	target=NULL;
	bNeedSave=false;
	filename=NULL;
	error=0;*/
}

CPrintLayoutParser::~CPrintLayoutParser()
{
   /*
	if(target) delete target;
	if(filename) delete filename;*/
}

int CPrintLayoutParser::Open(Glib::ustring &fname, CPrinter& prn)
{
   /*
	xmlDocPtr	doc;
   xmlNodePtr  node;
	xmlChar 	*buff;
	
	prn.GetParam(PRN_PARAM_PROTOCOL, &type);

		
	doc=xmlParseFile(fname);
	if(!doc){
	   error=1;
		return 1;
   }

	node=xmlDocGetRootElement(doc);
	if(node==NULL){
		xmlFreeDoc(doc);
		error=2;
		return 2;
	}
	ns=xmlSearchNsByHref(doc, node, (const xmlChar *) "http://bananapos.com/schemas/printlayout");
	if(ns==NULL){
		error=3;
		xmlFreeDoc(doc);
		return 3;
   }
   if(xmlStrcmp(node->name, (const xmlChar *) "PrintLayout")){
   	xmlFreeDoc(doc);
   	error=4;
		return 4;
	}
	
	while(node && xmlIsBlankNode(node)){
		node=node->next;
	}
   if(node==0){
      error=5;
      return 5;
   }

	node=node->xmlChildrenNode;
   while(node!=NULL){
      if((xmlStrcmp(node->name, (const xmlChar *) "printer")) || (node->ns!=ns))
   		ParsePrinter(node, prn);
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "setup")) || (node->ns!=ns))
   		ParseSetup(node, prn);
   	
   	if((xmlStrcmp(node->name, (const xmlChar *) "preprint")) || (node->ns!=ns))
   		ParsePrePrint(node, prn);   		
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "header")) || (node->ns!=ns))
   		ParseHeader(node, prn);

		if((xmlStrcmp(node->name, (const xmlChar *) "item")) || (node->ns!=ns))
   		ParseItem(node, prn);
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "transsummary")) || (node->ns!=ns))
   		ParseTransSum(node, prn);
   	
   	if((xmlStrcmp(node->name, (const xmlChar *) "footer")) || (node->ns!=ns))
   		ParseFooter(node, prn);
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "postprint")) || (node->ns!=ns))
   		ParsePostPrint(node, prn);
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "endorsement")) || (node->ns!=ns))
   		ParseEndorsement(node, prn);
   
   	if((xmlStrcmp(node->name, (const xmlChar *) "cheque")) || (node->ns!=ns))
   		ParseCheque(node, prn);
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "slip")) || (node->ns!=ns))
   		ParseSlip(node, prn);
   	
   	if((xmlStrcmp(node->name, (const xmlChar *) "label")) || (node->ns!=ns))
   		ParseLabel(node, prn);
   		
   	if((xmlStrcmp(node->name, (const xmlChar *) "barcode")) || (node->ns!=ns))
   		ParseBarcode(node, prn);
   		
		node=node->next;
	}

	xmlFreeDoc(doc);

	free(filename);
	filename=strdup(fname);
*/
	return 0;
}

void CPrintLayoutParser::ParsePrinter(xmlpp::Node node, CPrinter& prn)
{
   /*
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "target")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
			//target=strdup((char *) buff);
		}	
		node=node->next;
	}*/
}

void CPrintLayoutParser::ParseSetup(xmlpp::Node node, CPrinter& prn)
{
   /*
	xmlChar *buff;
	char	  temp[32];
	int 	  num;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "tabset")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "num");
			if(buff==NULL){ // set defaults
				
			}
			num=atoi((char *) buff);
			if(num < 1 || num > 32){	// parse error
				return;
			}
			//temp=strdup((char *) buff);
		}
		
		if((!xmlStrcmp(node->name, (const xmlChar *) "leftmargin")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "size");
		}
	}*/
}

void CPrintLayoutParser::ParsePrePrint(xmlpp::Node node, CPrinter& prn)
{
   /*
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}*/
}
/*
void CPrintLayoutParser::ParseHeader(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "select")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "target");
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "select")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "target");
		}	
		node=node->next;
	}
}


void CPrintLayoutParser::ParseItem(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "justify")) && (node->ns == ns)){
			//ParseJustify(node);
		}
		
		if((!xmlStrcmp(node->name, (const xmlChar *) "desciption")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "limit");
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "quantity")) && (node->ns == ns)){
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "price")) && (node->ns == ns)){
		}
	}
}

void CPrintLayoutParser::ParseTransSum(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParseFooter(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParsePostPrint(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "cut")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParseEndorsement(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParseCheque(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParseSlip(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParseLabel(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}

void CPrintLayoutParser::ParseBarcode(xmlNodePtr node, CPrinter& prn)
{
	xmlChar *buff;
	bool	  b;
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		if((!xmlStrcmp(node->name, (const xmlChar *) "manufacturer")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "name");
		}
	}
}


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Stuff ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/*
void CPrintLayoutParser::ParseTextAttribute(xmlNodePtr node, unsigned char *buff)
{     
	xmlChar *buff;
	
	buffcat(buff, 0x1B);
	
	unsigned int  charflags=0;
	unsigned char escbuff[3]={0x1B};
   if((!xmlStrcmp(node->name, (const xmlChar *) "em")) && (node->ns == ns)){
      switch(type){
      case ESCPOS:
         buffcat(buff, 0x45);
         buffcat(buff, 0x01);
         break;
      case DP8340:
      case STAR:
          buffcat(buff, 0x45);
          break;
      }
   }
	   
   if((!xmlStrcmp(node->name, (const xmlChar *) "ds")) && (node->ns == ns)){
      switch(type){
      case DP8340:
         break;
      case ESCPOS:
         buffcat(buff, 0x47);
         buffcat(buff, 0x01);
         break;
      case STAR:
         break;
      }
   }

   if((!xmlStrcmp(node->name, (const xmlChar *) "ul")) && (node->ns == ns)){
      switch(type){
      case DP8340:
      case STAR:
      case ESCPOS:
         buffcat(buff, 0x2D);
         buffcat(buff, 0x01);
         break;
      }
   }
   
   if((!xmlStrcmp(node->name, (const xmlChar *) "rev")) && (node->ns == ns)){
      switch(type){
      case DP8340:
      case STAR:
         break;
      case ESCPOS:
         buffcat(buff, 0x1D);
         buffcat(buff, 0x42);
         buffcat(buff, 0x01);
         break;
      }
   }

   if((!xmlStrcmp(node->name, (const xmlChar *) "upsdn")) && (node->ns == ns)){
      switch(type){
      case DP8340:
      case STAR:
         break;
      case ESCPOS:
         buffcat(buff, 0x7B);
         buffcat(buff, 0x01);
         break;
      }
   }
   
   if((!xmlStrcmp(node->name, (const xmlChar *) "rot")) && (node->ns == ns)){
      switch(type){
      case DP8340:
      case STAR:
         break;
      case ESCPOS:
         buffcat(buff, 0x56);
         buffcat(buff, 0x01);
         break;
      }
   }
}*/
/*
void CPrintLayoutParser::ParseInJustify(xmlNodePtr node, CPrinterBase& prn, unsigned int flags)
{
	xmlChar *buff;
	bool	  b;
	int		i;
	unsigned char escbuff[8]={0x1B};
	
	node=node->xmlChildrenNode;
	while(node!=NULL){
		// global print position parsers
		if((!xmlStrcmp(node->name, (const xmlChar *) "printlf")) && (node->ns == ns)){
			escbuff[0]=0x0A;
			//Output(1, escbuff);
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "printeject")) && (node->ns == ns)){
			escbuff[0]=0x0C;
			//Output(1, escbuff);
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "printcr")) && (node->ns == ns)){
			escbuff[0]=0x0D;
			//Output(1, escbuff);
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "tab")) && (node->ns == ns)){
			escbuff[0]=0x09;
			//Output(1, escbuff);
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "printdirection")) && (node->ns == ns)){
			if(flags & PRNLO_HAVEPAGEMODE){
				i=atoi((char *) xmlGetProp(node, (const xmlChar *) "type"));
				escbuff[1]=0x54;
				escbuff[2]=(unsigned char) i;
				//Output(3, escbuff);
			}
			else continue;
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "position")) && (node->ns == ns)){
			buff=xmlGetProp(node, (const xmlChar *) "type");
			if(!xmlStrcmp(buff, (const xmlChar *) "absolute")){
			}
			if(!xmlStrcmp(buff, (const xmlChar *) "relative")){
				buff=xmlGetProp(node, (const xmlChar *) "dir");
				i=atoi((char *) xmlGetProp(node, (const xmlChar *) "value"));
				escbuff[1]=0x5C;
				if(!xmlStrcmp(buff, (const xmlChar *) "right")){					
					escbuff[2]=LowByteValue(i);
					escbuff[3]=HiByteValue(i);
					//Output(4, escbuff);
				}
				else if(!xmlStrcmp(buff, (const xmlChar *) "left")){
					i-=65536;
					
				}
				else{	// error
				}
			}
		}
		
		
		if(flags && PRNLO_HEADER){
			if((!xmlStrcmp(node->name, (const xmlChar *) "text")) && (node->ns == ns)){
				buff=xmlGetProp(node, (const xmlChar *) "width");
				buff=xmlGetProp(node, (const xmlChar *) "height");
				// 0x01D, 0x21, n0:2 - height, n4:6 width
				
				buff=xmlGetProp(node, (const xmlChar *) "font");
				// 0x1B, 0x4D n=0,1
				
				buff=xmlGetProp(node, (const xmlChar *) "colour");
				// 0x1B, 0x72 n=0,1
				
				buff=xmlGetProp(node, (const xmlChar *) "codetable");
				// 0x1B, 0x74 n
				
				buff=xmlGetProp(node, (const xmlChar *) "usercharset");
				// 0x1B, 0x25 n (off, on)
				
				ParseText(node);
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "bitmap")) && (node->ns == ns)){
				ParseBitmap(node);
			}
		}
		if(flags && PRNLO_ITEM){
			if((!xmlStrcmp(node->name, (const xmlChar *) "desciption")) && (node->ns == ns)){
				buff=xmlGetProp(node, (const xmlChar *) "limit");
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "quantity")) && (node->ns == ns)){
				buff=xmlGetProp(node, (const xmlChar *) "format");
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "price")) && (node->ns == ns)){
				buff=xmlGetProp(node, (const xmlChar *) "format");
			}		
		}
		if(flags && PRNLO_FOOTER){
			
		}
		node=node->next;
	}	
}

void CPrintLayoutParser::ParseTextAttribute(xmlNodePtr node)
{
	xmlChar *buff;
	unsigned int  charflags=0;
	unsigned char escbuff[3]={0x1B};
	
	do{
		// add loop
		node=node->xmlChildrenNode;  // in <text> node
		while(node!=NULL){
			if((!xmlStrcmp(node->name, (const xmlChar *) "em")) && (node->ns == ns)){
				escbuff[1]=0x45;
				charflags|=PRNLO_CHAR_EMPHASIS;
				escbuff[2]=0x01;
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "ds")) && (node->ns == ns)){
				escbuff[1]=0x47;
				charflags|=PRNLO_CHAR_DBLSTRIKE;
				escbuff[2]=0x01;
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "ul")) && (node->ns == ns)){
				escbuff[1]=0x2D;
				charflags|=PRNLO_CHAR_UNDERLINE;
				escbuff[2]=0x01;
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "rev")) && (node->ns == ns)){
				escbuff[0]=0x1D;
				escbuff[1]=0x42;
				charflags|=PRNLO_CHAR_REVERSE;
				escbuff[2]=0x01;
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "upsdn")) && (node->ns == ns)){
				escbuff[1]=0x7B;
				charflags|=PRNLO_CHAR_UPSIDEDOWN;
				escbuff[2]=0x01;
			}
			if((!xmlStrcmp(node->name, (const xmlChar *) "rot")) && (node->ns == ns)){
				escbuff[1]=0x56;
				charflags|=PRNLO_CHAR_ROTATE;
				escbuff[2]=0x01;
			}
			
			//Output(3, escbuff);
			buff=xmlNodeGetContent(node);
			if(xmlStrlen(buff)!=0){
				//Output(xmlStrlen(buff), (char *) buff);
			}
			node=node->next;
		}
		
		// remove loop
		if((!xmlStrcmp(node->name, (const xmlChar *) "em")) && (node->ns == ns)){
			escbuff[1]=0x45;
			charflags&=~PRNLO_CHAR_EMPHASIS;
			escbuff[2]=0x00;
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "ds")) && (node->ns == ns)){
			escbuff[1]=0x47;
			charflags&=~PRNLO_CHAR_DBLSTRIKE;
			escbuff[2]=0x00;			
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "ul")) && (node->ns == ns)){
			charflags&=~PRNLO_CHAR_UNDERLINE;
			escbuff[2]=0x00;
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "rev")) && (node->ns == ns)){
			escbuff[0]=0x1D;
			escbuff[1]=0x42;
			charflags&=~PRNLO_CHAR_REVERSE;
			escbuff[2]=0x00;
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "upsdn")) && (node->ns == ns)){
			escbuff[1]=0x7B;
			charflags&=~PRNLO_CHAR_UPSIDEDOWN;
			escbuff[2]=0x00;
		}
		if((!xmlStrcmp(node->name, (const xmlChar *) "rot")) && (node->ns == ns)){
			escbuff[1]=0x56;
			charflags&=~PRNLO_CHAR_ROTATE;
			escbuff[2]=0x00;
		}
			
		//Output(3, escbuff);
	}while(charflags);
}
	
void CPrintLayoutParser::ParseBitmap(xmlNodePtr node)
{
	xmlChar *type, *mode, *buff;
	int		target;
	unsigned char escbuff[4]={0x1C, 0x70};
	
	type=xmlGetProp(node, (const xmlChar *) "type");
	mode=xmlGetProp(node, (const xmlChar *) "mode");
	
	if((!xmlStrcmp(buff, (const xmlChar *) "nvram"))){
		target=atoi((char *) xmlGetProp(node, (const xmlChar *) "target"));
//		escbuff[2]=target;
//		escbuff[3]=mode;
	}
	if((!xmlStrcmp(buff, (const xmlChar *) "download"))){	// unsuppoerted as yet...
	}
	//Output(4, escbuff);
}

void CPrintLayoutParser::ParseJustify(xmlNodePtr node)
{
	xmlChar *buff;
	unsigned char escbuff[3]={0x1B, 0x61};
	
	buff=xmlGetProp(node, (const xmlChar *) "type");
	
	if((!xmlStrcmp(buff, (const xmlChar *) "left"))){
		escbuff[2]=0x00;
	}
	if((!xmlStrcmp(buff, (const xmlChar *) "centre"))){
		escbuff[2]=0x01;
	}
	if((!xmlStrcmp(buff, (const xmlChar *) "right"))){
		escbuff[2]=0x02;
	}
	//Output(3, escbuff);
}

void CPrintLayoutParser::ParseFont(xmlNodePtr node)
{
	
	xmlChar *name;
	unsigned char escbuff[3]={0x1B, 0x61};
<font type="1">
				<spacing type="1.5">
}

unsigned char CPrintLayoutParser::LowByteValue(int i)
{
	float ret=i/256;
	if(i < 0) return 0;
	else return ((int) ret);
}

unsigned char CPrintLayoutParser::HiByteValue(int i)
{
	
	float ret=(i/256) - 256;
	
	if(ret < 0) return ((int) abs(ret));
	else return ((int) ret);
	return 0;
}

void CPrintLayoutParser::ParseColour(xmlNodePtr node)
{
}
*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Stuff ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

int CPrintLayoutParser::buffcat(unsigned char *, unsigned char)
{
   return 0;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Stuff ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/*
bool CPrintLayoutParser::GetOption(unsigned int param, void *data)
{
	if(data==NULL) return false;
	
	return false;
}

bool CPrintLayoutParser::SetOption(unsigned int param, void *data)
{
	if(data==NULL) return false;
	
	return false;
}

int CPrintLayoutParser::GetError()
{
   return error;
}
char *CPrintLayoutParser::GetErrorString(int err)
{
   switch(err){
   case 1:   return "failed to open file.";
   case 2:   return "empty document.";
   case 3:   return "document of the wrong type, PrnLayout Namespace not found.";
   case 4:   return "document of the wrong type, root node != PrintLayout.";
   case 5:   return "No elements found in document.";
   case 6:   return "";
   default:
      break;
   }
   
   return NULL;
}
*/
}

}
